/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- BBS: www.STCAIMCU.com  -----------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ            */
/*---------------------------------------------------------------------*/

#ifndef	__STC32G_CAN_H
#define	__STC32G_CAN_H

#include	"config.h"

//========================================================================
//                              
//========================================================================

#define	CAN1	0
#define	CAN2	1

#define	STANDARD_FRAME   0     //֡ʽ׼֡
#define	EXTENDED_FRAME   1     //֡ʽչ֡

#define CANBAUD          0xe0
#define CANDATA          0xe1

//SJW : ͬԾ  0~3
//SAM : ߵƽ  0:1; 1:3
//TSG1: ͬ1       0~15
//TSG2: ͬ2       1~7 (TSG2 Ϊ0)
//BRP : ʷƵϵ    0~63
//CAN߲=Fclk/((1+(TSG1+1)+(TSG2+1))*(BRP+1)*2)
#define CANBRT(SJW, SAM, TSG1, TSG2, BRP)   (u16)(((SJW << 6) + BRP) + (((SAM << 7) + (TSG2 << 4) + TSG1) << 8))

#define CANBRT_20K          CANBRT(0, 1, 13, 4, 29)     //24000000/((1+14+5)*30*2)=20KHz
#define CANBRT_40K          CANBRT(0, 1, 13, 4, 14)     //24000000/((1+14+5)*15*2)=40KHz
#define CANBRT_50K          CANBRT(0, 1, 5,  2, 23)     //24000000/((1+6+3)*24*2)=50KHz
#define CANBRT_80K          CANBRT(0, 1, 5,  2, 14)     //24000000/((1+6+3)*15*2)=80KHz
#define CANBRT_100K         CANBRT(0, 0, 5,  2, 11)     //24000000/((1+6+3)*12*2)=100KHz
#define CANBRT_125K         CANBRT(0, 0, 2,  1, 15)     //24000000/((1+3+2)*16*2)=125KHz
#define CANBRT_200K         CANBRT(0, 0, 5,  2, 5)      //24000000/((1+6+3)*6*2)=200KHz
#define CANBRT_250K         CANBRT(0, 0, 2,  1, 7)      //24000000/((1+3+2)*8*2)=250KHz
#define CANBRT_400K         CANBRT(0, 0, 5,  2, 2)      //24000000/((1+6+3)*3*2)=400KHz
#define CANBRT_500K         CANBRT(0, 0, 2,  1, 3)      //24000000/((1+3+2)*4*2)=500KHz
#define CANBRT_800K         CANBRT(0, 0, 1,  1, 2)      //24000000/((1+2+2)*3*2)=800KHz
#define CANBRT_1000K        CANBRT(0, 0, 2,  1, 1)      //24000000/((1+3+2)*2*2)=1000KHz

//========================================================================
//                              
//========================================================================

#define CAN_DOIM     0x01  //ж
#define CAN_BEIM     0x02  //ߴλж
#define CAN_TIM      0x04  //ж
#define CAN_RIM      0x08  //ж
#define CAN_EPIM     0x10  //λж
#define CAN_EWIM     0x20  //λж
#define CAN_ALIM     0x40  //ٲöʧж
#define CAN_ALLIM    0x7F  //ж

//========================================================================
//                              
//========================================================================

typedef struct
{
	u8	CAN_Enable;					//CANʹ  	ENABLE,DISABLE
	u8	CAN_IMR;						//CANжϼĴ 	CAN_DOIM,CAN_BEIM,CAN_TIM,CAN_RIM,CAN_EPIM,CAN_EWIM,CAN_ALIM,CAN_ALLIM,DISABLE

	u8	CAN_ACR0;						//մĴ 0~0xFF
	u8	CAN_ACR1;						//մĴ 0~0xFF
	u8	CAN_ACR2;						//մĴ 0~0xFF
	u8	CAN_ACR3;						//մĴ 0~0xFF
	u8	CAN_AMR0;						//μĴ 0~0xFF
	u8	CAN_AMR1;						//μĴ 0~0xFF
	u8	CAN_AMR2;						//μĴ 0~0xFF
	u8	CAN_AMR3;						//μĴ 0~0xFF
} CAN_InitTypeDef;

typedef struct
{
	u8	DLC:4;          //ݳ, bit0~bit3
	u8	:2;             //, bit4~bit5
	u8	RTR:1;          //֡, bit6
	u8	FF:1;           //֡ʽ, bit7
	u32	ID;             //CAN ID
	u8	DataBuffer[8];  //ݻ
}CAN_DataDef;

//========================================================================
//                              ⲿ
//========================================================================
extern bit B_Can1Read;     //CAN յݱ־
extern bit B_Can2Read;     //CAN յݱ־
extern bit bCan1TxBusy;    //CAN ͷæ־

u8 CanReadReg(u8 addr);
void CAN_Inilize(u8 CANx, CAN_InitTypeDef *CAN);
void CanSendMsg(u8 *CAN);
void CanSetBaudrate(u16 brt);
void CanReadMsg(void);
void CanPolling(void);

#endif
